% Polynom
% ------------


param.case  = 'Polynom';
param.beta  = 0.95;
a1 = 0.1; a2 = 0.3;


param.coef  = [0 , a1+1, a2-2*a1, a1-a2];

param.s = [0, 0.1, 1];
param.p = [0.9,0.9, 0.9;
    0.09,0.09, 0.09; 
    0.01,0.01, 0.01];

gridSize = 1/10000
gridPoints = 0:gridSize:1.6;
tol        = 0.0001;
IterMax    = 500;

[Vk, kOpt, Vy, kOptY]   =  Viterate(param, gridPoints, tol, IterMax);

save('PolynomSingle.mat', 'Vk', 'Vy', 'kOpt', 'kOptY', 'param', 'tol', 'gridPoints', 'IterMax')

maxK  = 1; %1.5*max(max(kOpt(:,2:end)));

index = kOpt(:,1)<=maxK;


% Plot
% -----
plotLC(kOpt, Vk, param, index,  'Polynom')
plotY(kOptY, Vy, param, index, 'Polynom')

k0 = 0.1*[1 1 1];
state0 = [1 1 1];
T = 20;
plotSimuPath(k0, state0, T, kOpt, Vk, param, 'Polynom')


% Calc OptCap
% ------------
p0 = cumsum(param.p)
coefP = param.coef(4:-1:1)
coefD = [3*coefP(1), 2*coefP(2), coefP(3)-1/param.beta]

kBench = sort(roots(coefD));
kBench = kBench(end);
kBench = p0 .* kBench;

fBench = [param.s' , polyval(coefP, kBench)]

kBench

max(kOpt(:,2:end))



