function [dStar, fStar] = calcDiv(kOpt, param)
% function [dStar, fStar] = calcDiv(kOpt param)
%
% Calculates the optimal dividends and the optimal production
% if the optimal capital is known

    % Consistency Checks and Initializations
    % ---------------------------------------

    param = checkParam(param);

    p = param.p;
    s = param.s;
    nOfStates = numel(s);

    if (size(kOpt, 2)-1) ~= nOfStates
        error('kOpt has wrong number of dimensions');
    end

    % Calculate fStar
    % ---------------

    fStar = kOpt;
    k     = repmat(kOpt(:,1), 1, nOfStates);
    s2    = 1:nOfStates;
    s2    = s(s2);
    s2    = repmat(s2', size(k, 1), 1);
    fStar(:,2:end) = f(k,  s2, param);


    % Calculate dStar
    % ---------------

    dStar = kOpt;
    dStar(:,2:end) = fStar(:,2:end) - kOpt(:,2:end);