function [index, weight, maxIndex]=calcIndexForVnY(y, param)
    
    if nargin~=2
        error('Wrong number of input arguments');
    end

    nOfS = numel(param.s);
    gridStep = y(2,1)-y(1,1);
    yNext = f(y, 0, param);
    yNext = repmat(yNext, 1, nOfS);

    for ss=1:nOfS
        yNext(:,ss) =  yNext(:,ss) - param.s(ss);
    end 

    weight = yNext/gridStep;
    index = floor(weight);
    temp  = index<1;
    index(temp) = 1;
    weight = weight -index;
    weight(temp) =  0;

    maxIndex = max(max(index(end,:))+1,size(y,1));

    for ss=1:nOfS
       index(:,ss) =  index(:,ss) + maxIndex*ss;
    end


end