function kNext = calcKopt(k, state, kOpt)
% function kNext = calcKopt(k or y, state, kOpt or kOptY)
%
% Determines kOpt given the capital the state and kOpt


% Consistency checks
% -------------------

if size(k) ~= size(state)
    error('k and s need the same size');
end

oldSize = size(k);
k = vec(k);
state = vec(state);

state = fix(state);
numOfStates = size(kOpt, 2)-1;

if any(max(state)>(size(kOpt, 2)-1))
    error('state higher than states in kOpt');
end

if any(state<1)
    error('states need to be at least 1');
end

% Evaluate kOpt
% -------------

kNext = NaN(size(k));

for s = 1:numOfStates
  kNext(state==s) = interp1(kOpt(:,1), kOpt(:,s+1), k(state==s), 'linear');
end

kNext = reshape(kNext, oldSize);