function V=evalV(k, state, Vpre)
% function V=evalV(k or y, state, Vpre or VyPre)
%
% Evaluates Vpre at k, state


% Consistency checks
% -------------------

if size(k) ~= size(state)
    error('k and s need the same size');
end

oldSize = size(k);
k = vec(k);
state = vec(state);

state = fix(state);
numOfStates = size(Vpre, 2)-1;

if any(max(state)>(size(Vpre, 2)-1))
    error('state higher than states in Vpre');
end

if any(state<1)
    error('states need to be at least 1');
end

kMax = Vpre(end, 1);

% Evaluate Vpre
% -------------

V = NaN(size(k));

for s = 1:numOfStates
   temp = state==s & k<=kMax & k>=0;
   if any(any(any(temp)))
       V(temp) = interp1(Vpre(:,1), Vpre(:,s+1), k(temp), 'linear');
   end

   % For negative k V is 0
   V(k<0) = 0;
   
   % If k to big assume slope of V = 1
   temp = state==s & k>kMax;
   V(temp) = Vpre(end,s+1) + 1*(k(temp)-kMax);
end

V = reshape(V, oldSize);