function plotLCSingle(kOptY, Vy, param, pDie, yGrowth, Vgrowth, Vvola, ExpRet, VolaRet, ExpROI, VolaROI, showPeriods, index, folder)
% function plotLC(kOpt, V, param, index, folder)
%
% plots graphs to the Life Cycle of companies

param = checkParam(param);
maxStates = size(kOptY,2)-1;

lw = 1;

if nargin<14
    folder = 'lastRun';
end

if nargin>=13
    y = kOptY(index,1);
else
    y = kOptY(:,1);
end

% if 7== exist('f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\','dir')
%     defaultPath = 'f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\';
% elseif 7== exist('C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\','dir')
%     defaultPath = 'C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\';
% else
    mkdir(cd, 'Graphs');
    defaultPath = strcat(cd, '\Graphs\');
% end


path = strcat(defaultPath, folder, '\');

filename=strcat(path,'data.xlsx');

lineTypes = '-|--|:|-.|*|.-|--|:';
set(0, 'DefaultAxesColorOrder',[0 0 1],...
      'DefaultAxesLineStyleOrder',lineTypes);
xLimits = [min(Vy(:,1)) max(Vy(:,1))];




colnames2 = {'y', 'T=1', 'T=2', 'T=3', 'T=4', 'T=5'};


for s=1:maxStates
    
    % Everything in growth and in y
    % ---------------------------------------
    
    figure;
    title(strcat('State ', num2str(s)));
    xyLimits = [min(y) max(y)];
    if (any(isnan(xyLimits))| xyLimits(2)-xyLimits(1)<=0)
        xyLimits =xLimits
    end
    
    
    % Probability to Die
    % ------------------
%     subplot(2,2,1);
    plot(y, squeeze(pDie(:,s,showPeriods)), 'LineWidth', lw)
%     title('(a) Probability to Die');
     xlabel('y');
    ylim([-0.0001 1.1*max(quantile(squeeze(pDie(:,s,showPeriods)),.95))]);
    xlim(xyLimits);
    
    sheetname = 'LcPdie';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(pDie(:,s,showPeriods))], 'yP');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(pDie(:,s,:))], ...
        colnames2, ... 
        {strcat('Probability to die in T periods', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Exp. Growth of  Endowment
    % -------------------------
%     subplot(2,2,2);
    plot(y, squeeze(yGrowth(:,s,showPeriods)), 'LineWidth', lw)
    temp = max(max(squeeze(yGrowth(:,s,showPeriods))));
    temp = min(1.05*temp, 2);
    ylim([-0.05, temp]);
%     title('(b) Exp. Growth of Endowment');
     xlabel('y');
    xlim(xyLimits);
    
    sheetname = 'LcYGrowth';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(yGrowth(:,s,showPeriods))], 'y, yGrowth');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(yGrowth(:,s,:))], ...
        colnames2, ... 
        {strcat('Growth of initial endowment over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Exp. Growth of Value
    % --------------------
%     subplot(2,2,3);
    plot(y, squeeze(Vgrowth(:,s,showPeriods)), 'LineWidth', lw)
%     title('(c) Exp. Growth of NPV');
     xlabel('y');
    temp = max(quantile(squeeze(Vgrowth(:,s,showPeriods)), .95));
    temp = min(1.05*temp, 2);
    ylim([-0.05, temp]);
    xlim(xyLimits);

    sheetname = 'LcVgrowth';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(Vgrowth(:,s,showPeriods))], 'yV');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(Vgrowth(:,s,:))], ...
        colnames2, ... 
        {strcat('Growth of the value function over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Volatility in Growth of Value
    % ------------------------------------------
%     subplot(2,2,4);
    plot(y, squeeze(Vvola(:,s,showPeriods)), 'LineWidth', lw)
%     title('(d) Volatility of Growth in NPV');
     xlabel('y');
    temp = max(quantile(squeeze(Vvola(:,s,showPeriods)), .95));
    temp = min(1.05*temp, 2);
    ylim([-0.01, temp]);
    xlim(xyLimits);
    
    sheetname = 'LcVvola';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(Vvola(:,s,showPeriods))], 'yV');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(Vvola(:,s,:))], ...
        colnames2, ... 
        {strcat('Volatility of the value function over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Expected Return
    %%%%%%%%%%%%%%%%%%
    
    plot(y, squeeze(ExpRet(:,s,showPeriods)), 'LineWidth', lw)
    xlim(xyLimits);
    xlabel('y');
    
    sheetname = 'LcExpRet';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(ExpRet(:,s,showPeriods))], 'yR');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(ExpRet(:,s,:))], ...
        colnames2, ... 
        {strcat('Expected return (V_t+T / (V_t-d_t) over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Volatility
    %%%%%%%%%%%%%
    
    plot(y, squeeze(VolaRet(:,s,showPeriods)), 'LineWidth', lw)
    xlim(xyLimits);
    xlabel('y');
    sheetname = 'LcVolaRet';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(VolaRet(:,s,showPeriods))], 'yR');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(VolaRet(:,s,:))], ...
        colnames2, ... 
        {strcat('Volatility of the return (V_t+T / (V_t-d_t) over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    
    
    % Expected ROI
    %%%%%%%%%%%%%%%%%%
    
    plot(y, squeeze(ExpROI(:,s,showPeriods)), 'LineWidth', lw)
    xlim(xyLimits);
    xlabel('y');
    
    sheetname = 'LcExpROI';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(ExpROI(:,s,showPeriods))], 'yR');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(ExpROI(:,s,:))], ...
        colnames2, ... 
        {strcat('Expected return (V_t+T / (k_t) over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    % Volatility of ROI
    %%%%%%%%%%%%%%%%%%%%
    
    plot(y, squeeze(VolaROI(:,s,showPeriods)), 'LineWidth', lw)
    xlabel('y')
    xlim(xyLimits);
    sheetname = 'LcVolaROI';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [y, squeeze(VolaROI(:,s,showPeriods))], 'yR');
    saveToXLSX(filename,sheetname,...
         [y, squeeze(VolaROI(:,s,:))], ...
        colnames2, ... 
        {strcat('Volatility of the return (V_t+T / (k_t) over T periods starting in S=', num2str(s))});
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    
    % Mean Variance Diagram
    % ----------------------
    


    plot(squeeze(VolaROI(:,s,showPeriods)), squeeze(ExpROI(:,s,showPeriods)), 'LineWidth', lw);
    xlabel('Volatility');
    ylabel('Expected Return');
    sheetname = 'MeanVarianceROIT1';
    sheetname = strcat(sheetname, num2str(s));
    saveToTXT(strcat(path,sheetname, '.txt'), ...
         [squeeze(VolaROI(y>1,s,:)), squeeze(ExpROI(y>1,s,:))], 'vr');
    try
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    catch %if there is no directory create one
        mkdir(defaultPath, folder)
        exportfig(gcf,strcat(path, sheetname, '.eps'), 'width',10, 'fontmode','fixed', 'fontsize',8);
    end
    
    
    
    
%     if s==1
%         pDie1 = [y squeeze(pDie(:,1,:))];
%         yGrowth1 = [y squeeze(yGrowth(:,1,:))];
%         Vgrowth1 = [y squeeze(Vgrowth(:,1,:))];
%         Vvola1 = [y squeeze(Vvola(:,1,:))];
%         ExpRet1 = [y squeeze(ExpRet(:,1,:))];
%         VolaRet1 = [y squeeze(VolaRet(:,1,:))];
%     end
end




function [numOfX, numOfY] = positionsInSubPlot(numOfGraph)
    % determines position in a subplot out of the number of graphs
    
    numOfGraph = ceil(numOfGraph);
    if numOfGraph<1
        error('numOfGraph must be at least 1')
    elseif numOfGraph == 1
        numOfX = 1; numOfY = 1;
    elseif numOfGraph == 2
        numOfX = 2; numOfY = 1;
    elseif numOfGraph == 3
        numOfX = 3; numOfY = 1;
    elseif numOfGraph == 4
        numOfX = 2; numOfY = 2;
    elseif numOfGraph == 5 | numOfGraph == 6
        numOfX = 3; numOfY = 2;
    elseif numOfGraph == 8 | numOfGraph == 7
        numOfX = 4; numOfY = 2;
    elseif numOfGraph == 9 
        numOfX = 3; numOfY = 3;
    elseif numOfGraph == 10
        numOfX = 5; numOfY = 2;
    elseif numOfGraph == 11 | numOfGraph == 12
        numOfX = 4; numOfY = 3;
    elseif numOfGraph == 13 | numOfGraph == 14 | numOfGraph == 15
        numOfX = 5; numOfY = 3;
    elseif numOfGraph == 16 
        numOfX = 4; numOfY = 4;
    elseif numOfGraph == 17 | numOfGraph == 18 
        numOfX = 6; numOfY = 3;
    elseif numOfGraph == 19 | numOfGraph == 20 
        numOfX = 5; numOfY = 4;
    elseif numOfGraph == 21 
        numOfX = 7; numOfY = 3;
    elseif numOfGraph == 22 | numOfGraph == 23 | numOfGraph == 24
        numOfX = 6; numOfY = 4;
    elseif numOfGraph == 25
        numOfX = 5; numOfY = 5;
    elseif numOfGraph == 26 | numOfGraph == 27 | numOfGraph == 28
        numOfX = 7; numOfY = 4;
    elseif numOfGraph == 29 | numOfGraph == 30 
        numOfX = 6; numOfY = 5;
    else
        error('To many graphs (more than 30)');
    end
    
function legends(agentNames, location)
    if nargin==1
        location = 0;
    end

    if size(agentNames, 1) == 1
        legend(agentNames(1,:), location);
    elseif size(agentNames, 1) == 2
        legend(agentNames(1,:), agentNames(2,:), location);
    elseif size(agentNames, 1) == 3
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), location);
    elseif size(agentNames, 1) == 4
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), location);
    elseif size(agentNames, 1) == 5
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), location);
     elseif size(agentNames, 1) == 6
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
             agentNames(6,:), location);
     elseif size(agentNames, 1) == 7
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
            agentNames(6,:), agentNames(7,:), location);
    else
        error('to many legends');
    end
    