function plotMultSY(kOpt, V, kOptY, Vy, param, gridPoints, s,  folder)
% function plotMultSY(kOpt, V, kOptY, Vy, param, s,  folder)
%
% plots graphs to the Life Cycle of companies


stepSize = max(1,floor(size(kOpt,1)/500));
index = 1:stepSize:size(kOpt,1);
kOpt = kOpt(index,:,:);
V    = V(index,:,:);
kOptY = kOptY(index,:,:);
Vy    = Vy(index,:,:);
gridPoints = gridPoints(index);
letters = ['(a)'; '(b)'; '(c)'; '(d)'; '(e)'; '(f)'];
stateNames =[' Boom     '; ' Recession'];

param = checkParam(param);
maxStates = size(kOpt,2)-1;

lw = 2;

if nargin<4
    error('not enough input arguments');
end
% 

if nargin<5
    folder = 'lastRun';
end

% if 7== exist('f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\','dir')
%     defaultPath = 'f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\';
% elseif 7== exist('C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\','dir')
%     defaultPath = 'C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\';
% else
%    mkdir(cd, 'Graphs');
    defaultPath = strcat(cd, '\Graphs\');
% end

path = strcat(defaultPath, folder, '\');


lineTypes = '-|--|:|-.|*|.-|--|:';
set(0, 'DefaultAxesColorOrder',[0 0 1],...
      'DefaultAxesLineStyleOrder',lineTypes)

% try
%     save(strcat(path,'OptK') , 'kOpt', 'V', 'param', 's');
% catch %if there is no directory create one
%     mkdir(defaultPath, folder)
%     saveas(gcf, strcat(path,'OptK') , 'epsc');
% end

  
% 
% % Optimal Capital (Next Period)
% % ------------------------------
% 
% figure;
%  
maxK = squeeze(max(kOpt, [], 1));
% 
% for ii = 1:numel(maxK(2,:))
%    maxK(3,ii) = interp1(kOpt(:,1,ii), kOpt(:,3,ii) ,maxK(2,ii) );
% end
% 
% kToSurvive = NaN(numel(s), 1);
% state = 2;
% for ii = 1:numel(s)
%     param.s(state) = s(ii);  
%     start =  [0, ( (1+param.delta)/param.gamma/param.alpha)^(1/(param.alpha-1))];
%     temp = fSupportable(start, state, param);
%     if temp(2) <0
%         kToSurvive(ii) = NaN; 
%     else
%         kToSurvive(ii) = fzero(@(k) fSupportable(k, state, param), start); 
%     end
% end
% 
% subplot(2,1,1);
% plot(s, [maxK(2,:)', kToSurvive], 'LineWidth', lw);
% title('Optimal Capital Stock in the Next Period')
% ylabel('s=1')
% xlabel('Shock Size')
% ylim([0, 1.1*max(max(max(maxK(2:3,:)))) ] );
% 
% subplot(2,1,2);
% plot(s, [maxK(3,:)', kToSurvive], 'LineWidth', lw);
% ylabel('s=2')
% xlabel('Shock Size')
% ylim([0, 1.1*max(max(max(maxK(2:3,:)))) ] );
% 
% saveas(gcf, strcat(path,'OptK') , 'epsc');
% 
% 
% % Optimal Dividend (Actual Period)
% % ---------------------------------
% 
% 
% d = NaN(numel(s), numel(param.s)+1);
% dOpt = kOpt;
% for ii = 1:numel(s)
%     param.s(2) = s(ii);    
%     [dStar, fStar] = calcDiv(kOpt(:,:,ii), param);
%     dOpt(:,:,ii) = dStar;
%     d(ii, 1) = interp1(dStar(:,1),dStar(:,2),maxK(2,ii));
%     d(ii, 3) = interp1(dStar(:,1),dStar(:,3),maxK(3,ii));
%     %d(ii, 3) = interp1(dStar(:,1),dStar(:,3), min(maxK(2:3,ii), [], 2));
%     d(ii, 2) = interp1(dStar(:,1),dStar(:,3),maxK(2,ii));
% end
% 
% figure;
% subplot(3,1,1)
% plot(s, d(:,1), 'LineWidth', lw)
% title('Dividend Policy')
% ylabel('s=1')
% xlabel('Shock Size')
% ylim([0, 1.1*max(max(max(d(:,[1,3])))) ] );
% 
% subplot(3,1,2)
% plot(s, d(:,2), 'LineWidth', lw)
% ylabel('s=2 with capital from s=1')
% xlabel('Shock Size')
% 
% subplot(3,1,3)
% plot(s, d(:,3), 'LineWidth', lw)
% ylabel('s=2')
% xlabel('Shock Size')
% ylim([0, 1.1*max(max(max(d(:,[1,3])))) ] );
%     
% try
%     saveas(gcf, strcat(path,'OptD') , 'epsc');
% catch %if there is no directory create one
%     mkdir(defaultPath, folder)
%     saveas(gcf, strcat(path,'OptD') , 'epsc');
% end
% 
% Dividends starting from Optimal k
% ---------------------------------
% 
% tt = [0 1 2 5];
% tMax = max(tt);
% dt = NaN(numel(s), tMax+1);
% kt = NaN(numel(s), tMax+1);
% dt(:,1) = d(:,1);
% kt(:,1) = maxK(2,:)';
% for t = 1:tMax
%     for ii = 1:numel(s)
%         kt(ii, t+1) = interp1(kOpt(:,1,ii), kOpt(:,3,ii), kt(ii,t));
%         dt(ii, t+1) = f(kt(ii,t), s(ii), param) - kt(ii, t+1);
%     end
% end
% 
% % Plot kt
% %--------
% 
% ktMax = 1.05*max(max(kt));
% kKill = 0:(ktMax/1000):ktMax;
% sKill = f(kKill, 0, param);
% 
% figure;
% for ii = 1:numel(tt)
% 
%     subplot(ceil(numel(tt)/2), 2, ii)
%     plot(s, [kt(:,tt(ii)+1), kToSurvive], 'LineWidth', lw)    
%     ylabel(strcat('t=', num2str(tt(ii))));
%     hold on
%     plot(sKill, kKill, ':', 'LineWidth', lw)
%     hold off
%     
%     if ii==numel(tt) | ii == numel(tt)-1
%         xlabel('Shock Size')
%     end
%     ylim([0, ktMax]);
% 
% end
% saveas(gcf, strcat(path,'kt') , 'epsc');
% 
% % Plot dt
% %--------
% figure;
% dtMax = 1.05*max(max(dt));
% for ii = 1:numel(tt)
%     subplot(ceil(numel(tt)/2), 2, ii)
%     plot(s, dt(:,tt(ii)+1), 'LineWidth', lw)
%     ylabel(strcat('t=', num2str(tt(ii))));
%     if ii == numel(tt) | ii == numel(tt)-1
%         xlabel('Shock Size')
%     end
%     ylim([0, dtMax]);
% 
% end
% saveas(gcf, strcat(path,'dt') , 'epsc');

% NPV depending on S and Y
% ------------------------------

figure;
index = gridPoints<= 1.25 * f(max(max(max(kOptY(:, 2:end, :)))),0, param);
[X, Y] = ndgrid(gridPoints(index), s');
for ii = 1:(size(Vy, 2)-1)
    subplot(1,(size(Vy, 2)-1), ii);
    [C,h] = contour(X, Y, squeeze(Vy(index,ii+1,:)));
    set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
    colormap cool
    title(strcat(letters(ii,:), stateNames(ii,:)));
    xlabel('y');
    
    if (ii == (size(Vy, 2)-1))
        ylabel('Shock');
    end
    ylim([0, 8])
end

try
    saveas(gcf, strcat(path,'NPVy') , 'epsc');
catch %if there is no directory create one
    mkdir(defaultPath, folder)
    saveas(gcf, strcat(path,'NPVy') , 'epsc');
end



% kNext
% -----

figure;
[X, Y] = ndgrid(gridPoints(index), s');
for ii = 1:(size(kOpt, 2)-1)
    subplot(1,(size(kOptY, 2)-1), ii);
    [C,h] = contour(X, Y, squeeze(kOptY(index,ii+1,:)));
    set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
    colormap cool
    title(strcat(letters(ii,:), stateNames(ii,:)));
    xlabel('y');
    ylabel('Shock');
    ylim([0, 8])
end
saveas(gcf, strcat(path,'kNextY') , 'epsc');


% DivOpt
% ------

dOptY = repmat(Vy(:,1,1), [1, size(kOptY,2), size(kOptY,3)] ) -kOptY;

figure;
[X, Y] = ndgrid(gridPoints(index), s');
for ii = 1:(size(kOpt, 2)-1)
    subplot(1,(size(dOptY, 2)-1), ii);
    [C,h] = contour(X, Y, squeeze(dOptY(index,ii+1,:)));
    set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
    colormap cool
   title(strcat(letters(ii,:), stateNames(ii,:)));
    xlabel('y');
    ylabel('Shock');
end
saveas(gcf, strcat(path,'dOptY') , 'epsc');

% % Probability to die
% % ------------------
% T = 3;
% index = kOpt(:,1,1)<=1.1*max(max(max(kOpt(:,2:end,:))));
% showPeriods = [1 2 T];
% pDD = NaN(numel(s), numel(showPeriods), maxStates);
% pD = NaN(sum(index), maxStates, T, numel(s)); 
% gY = NaN(sum(index), maxStates, T, numel(s)); 
% gV = NaN(sum(index), maxStates, T, numel(s)); 
% vola = NaN(sum(index), maxStates, T, numel(s)); 
% 
% pDy = NaN(numel(gridPoints), maxStates, T, numel(s)); 
% gYy = NaN(numel(gridPoints), maxStates, T, numel(s)); 
% gVy = NaN(numel(gridPoints), maxStates, T, numel(s)); 
% volaY = NaN(numel(gridPoints), maxStates, T, numel(s)); 
% 
% for ii = 1:numel(s)
%     param.s(2) = s(ii);    
%     [pDie, kAbs, kRel, kGrowth, Vabs, Vrel, Vgrowth, VabsVola, VrelVola, Vvola, yRel]= ...
%         calcVars(kOpt(:,:,ii), V(:,:,ii), param, T, index);
%     
%     pDie(isnan(pDie)) = 1;
%     pD(:,:,:,ii) = pDie;
%     gY(:,:,:,ii) = yRel;
%     gV(:,:,:,ii) = Vrel;
%     vola(:,:,:,ii) = VrelVola;
%     
%     
%     
%     for ss = 1:maxStates
%         y = f(kOpt(index,1,1), param.s(ss), param);
%         doubleIndex = [false; y(2:end)== y(1:(end-1))];
%         doubleIndex(isnan(y)) = true;
%         if sum(~doubleIndex)>1
%             for jj = 1:numel(showPeriods)
%                 warning('off');
%                 pDy(:,ss,showPeriods(jj),ii) = interp1(y(~doubleIndex), ...
%                     pDie(~doubleIndex,ss,showPeriods(jj)), gridPoints);
%                 gYy(:,ss,showPeriods(jj),ii) = interp1(y(~doubleIndex), ...
%                     kRel(~doubleIndex,ss,showPeriods(jj)), gridPoints);
%                 gVy(:,ss,showPeriods(jj),ii) = interp1(y(~doubleIndex), ....
%                     Vrel(~doubleIndex,ss,showPeriods(jj)), gridPoints);
%                 volaY(:,ss,showPeriods(jj),ii) = interp1(y(~doubleIndex), ...
%                     VrelVola(~doubleIndex,ss,showPeriods(jj)), gridPoints);
%                 warning('on', 'all');
%             end
%         end
%     end
%     
% %     for ss = 1:maxStates
% %         for jj = 1:numel(showPeriods)
% %             pDD(ii, jj, ss) = interp1(f(kOpt(index,1,1), param.s(ss), param),...
% %                 pDie(:,ss, showPeriods(jj)),...
% %                 maxK(2,ii));
% %         end
% %     end
% 
% end


% figure;
% for jj = 1:numel(showPeriods)
%    for ss = 1:maxStates
%        subplot(numel(showPeriods), maxStates, (jj-1) * maxStates + ss);
%        plot(s, pDD(:, jj, ss), 'LineWidth', lw);
%        ylim([-.05, 1.05]);
%        if ss==1
%             ylabel(strcat('t=', num2str(showPeriods(jj))));
%        end
% 
%        if jj == 1
%            title(strcat('State ', num2str(ss)));
%        end
%        
%        if jj == numel(showPeriods);
%            xlabel('Shock Size');
%        end
%    end
% end
% saveas(gcf, strcat(path,'pDD') , 'epsc');

% pD
% ------
% 
% figure;
% [X, Y] = ndgrid(gridPoints, s');
% for ii = 1:(size(kOpt, 2)-1)
%     subplot(1,(size(kOpt, 2)-1), ii);
%     [C,h] = contour(X, Y, squeeze(pDy(:,ii,T,:)));
%     set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
%     colormap cool
%     title(strcat(letters(ii,:), stateNames(ii,:)));
%     xlabel('y');
%     ylabel('Shock');
%     ylim([0, 8])
% end
% saveas(gcf, strcat(path,'pDy') , 'epsc');
% 
% 
% % Growth of Initial Endowment
% % -----------------------------
% 
% figure;
% [X, Y] = ndgrid(gridPoints, s');
% for ii = 1:(size(kOpt, 2)-1)
%     subplot(1,(size(kOpt, 2)-1), ii);
%     [C,h] = contour(X, Y, squeeze(gYy(:,ii,T,:)));
%     set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
%     colormap cool
%     title(strcat(letters(ii,:), stateNames(ii,:)));
%     xlabel('y');
%     ylabel('Shock');
% end
% saveas(gcf, strcat(path,'gYy') , 'epsc');
% 
% 
% % Volatility
% % -------------------
% 
% figure;
% [X, Y] = ndgrid(gridPoints, s');
% for ii = 1:(size(kOpt, 2)-1)
%     subplot(1,(size(kOpt, 2)-1), ii);
%     [C,h] = contour(X, Y, squeeze(volaY(:,ii,T,:)));
%     set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
%     colormap cool
%     title(strcat(letters(ii,:), stateNames(ii,:)));
%     xlabel('y');
%     ylabel('Shock');
%     ylim([0, 8])
% end
% saveas(gcf, strcat(path,'volaY') , 'epsc');
% 
% 
% % Growth of Value
% % -------------------
% 
% figure;
% [X, Y] = ndgrid(gridPoints, s');
% for ii = 1:(size(kOpt, 2)-1)
%     subplot(1,(size(kOpt, 2)-1), ii);
%     [C,h] = contour(X, Y, squeeze(gVy(:,ii,T,:)));
%     set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2);
%     colormap cool
%     title(strcat(letters(ii,:), stateNames(ii,:)));
%     xlabel('y');
%     ylabel('Shock');
%     ylim([0, 8])
% end
% saveas(gcf, strcat(path,'gVy') , 'epsc');


function gain = fSupportable(k, state, param)
    % calculates the gain given the parameters
    % in the bad state
    
    gain = f(k, 0, param)- param.s(state) - k;

function [numOfX, numOfY] = positionsInSubPlot(numOfGraph)
    % determines position in a subplot out of the number of graphs
    
    numOfGraph = ceil(numOfGraph);
    if numOfGraph<1
        error('numOfGraph must be at least 1')
    elseif numOfGraph == 1
        numOfX = 1; numOfY = 1;
    elseif numOfGraph == 2
        numOfX = 2; numOfY = 1;
    elseif numOfGraph == 3
        numOfX = 3; numOfY = 1;
    elseif numOfGraph == 4
        numOfX = 2; numOfY = 2;
    elseif numOfGraph == 5 | numOfGraph == 6
        numOfX = 3; numOfY = 2;
    elseif numOfGraph == 8 | numOfGraph == 7
        numOfX = 4; numOfY = 2;
    elseif numOfGraph == 9 
        numOfX = 3; numOfY = 3;
    elseif numOfGraph == 10
        numOfX = 5; numOfY = 2;
    elseif numOfGraph == 11 | numOfGraph == 12
        numOfX = 4; numOfY = 3;
    elseif numOfGraph == 13 | numOfGraph == 14 | numOfGraph == 15
        numOfX = 5; numOfY = 3;
    elseif numOfGraph == 16 
        numOfX = 4; numOfY = 4;
    elseif numOfGraph == 17 | numOfGraph == 18 
        numOfX = 6; numOfY = 3;
    elseif numOfGraph == 19 | numOfGraph == 20 
        numOfX = 5; numOfY = 4;
    elseif numOfGraph == 21 
        numOfX = 7; numOfY = 3;
    elseif numOfGraph == 22 | numOfGraph == 23 | numOfGraph == 24
        numOfX = 6; numOfY = 4;
    elseif numOfGraph == 25
        numOfX = 5; numOfY = 5;
    elseif numOfGraph == 26 | numOfGraph == 27 | numOfGraph == 28
        numOfX = 7; numOfY = 4;
    elseif numOfGraph == 29 | numOfGraph == 30 
        numOfX = 6; numOfY = 5;
    else
        error('To many graphs (more than 30)');
    end
    
function legends(agentNames, location)
    if nargin==1
        location = 0;
    end

    if size(agentNames, 1) == 1
        legend(agentNames(1,:), location);
    elseif size(agentNames, 1) == 2
        legend(agentNames(1,:), agentNames(2,:), location);
    elseif size(agentNames, 1) == 3
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), location);
    elseif size(agentNames, 1) == 4
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), location);
    elseif size(agentNames, 1) == 5
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), location);
     elseif size(agentNames, 1) == 6
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
             agentNames(6,:), location);
     elseif size(agentNames, 1) == 7
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
            agentNames(6,:), agentNames(7,:), location);
    else
        error('to many legends');
    end
    