function plotY(kOpt, V, param, index, folder)
% function plotLC(kOptY, Vy, param, index, folder)
%
% plots graphs to the Life Cycle of companies

param = checkParam(param);
maxStates = size(kOpt,2)-1;

lw = 2;
xLimits = [min(V(index,1)) max(V(index,1))]

if nargin<3
    error('not enough input arguments');
end

if nargin>=4
    kOpt = kOpt(index,:);
    V    = V(index,:);
end

if nargin<5
    folder = 'lastRun';
end

% if 7== exist('f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\','dir')
%     defaultPath = 'f:\Uni\SS 06\evoModel\OutputFromHome\Graphs\';
% elseif 7== exist('C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\','dir')
%     defaultPath = 'C:\Documents and Settings\Urs\My Documents\evoModel\OutputFromOffice\Graphs\';
% else
    mkdir(cd, 'Graphs');
    defaultPath = strcat(cd, '\Graphs\');
% end

path = strcat(defaultPath, folder, '\');


lineTypes = '-|--|:|-.|*|.-|--|:';
set(0, 'DefaultAxesColorOrder',[0 0 1],...
      'DefaultAxesLineStyleOrder',lineTypes)


% % relative Weahlth with confidence Intervals
% figure;
% relWealth = m.wealth ./ repmat(sum(m.wealth, 2), 1, numOfInvestors);
% aMean = mean(relWealth, 3);
% aLowQ = quantileDim(relWealth, alpha/2, 3);
% aHighQ = quantileDim(relWealth, 1-alpha/2, 3);
% plot(index, aMean(index,:,:), index, aLowQ(index,:,:), ':', ...
%     index, aHighQ(index,:,:), ':');
% axis([min(index), max(index), 0, 1]);
% title('Relative Wealth');
% xlabel(cat(2, 'Mean and  ', num2str(100*(1-alpha)), '% Confidence Interval'));
% legends(m.struct.strategies(m.struct.investors,:));


% Overview over functions
% ------------------------

figure;
 
subplot(1,2,1);
plot(V(:,1), V(:,2:end), 'LineWidth', lw)
title('(a) Value Function');
ylabel('V');
xlabel('y');
xlim(xLimits)
 
subplot(2,2,2);
plot(kOpt(:,1), kOpt(:,2:end), 'LineWidth', lw)
title('(b) Optimal Capital in the Next Period');
ylabel('k^*_{t+1}');
xlabel('y');
xlim(xLimits)

nS = size(kOpt,2)-1;
nG = size(kOpt,1);
dStar  = [kOpt(:,1), repmat(kOpt(:,1),1,nS)- kOpt(:,2:end)];
s = repmat(param.s', nG,1);
fStar = [kOpt(:,1), f(repmat(kOpt(:,1),1,nS), s, param)];
%[dStar, fStar] = calcDivY(kOpt, param);
xlim(xLimits)

subplot(2,2,4);
plot(dStar(:,1), dStar(:,2:end), 'LineWidth', lw)
title('(c) Optimal Dividend Payment');
ylabel('d^*');
xlabel('y');
xlim(xLimits) 


% subplot(2,2,4);
% plot(dStar(:,1), dStar(:,2:end)./V(:,2:end),...
%     'LineWidth', lw);
% ylabel('d^*/V');
% xlabel('y');
% title('(d) Dividend Yield');
% xlim(xLimits)


% subplot(2,2,4);
% plot(dStar(:,1), dStar(:,2:end)./repmat(dStar(:,1),1,nS),...
%     'LineWidth', lw);
% ylabel('d^*/y');
% xlabel('y');
% title('(d) Payout Quota');
% xlim(xLimits)
% plot(fStar(:,1), fStar(:,2:end), 'LineWidth', lw)
% title('Production Function');
% ylabel('f(y, s)');
% xlabel('y');

try
    saveas(gcf, strcat(path,'LcOverviewY') , 'epsc');
catch %if there is no directory create one
    mkdir(defaultPath, folder)
    saveas(gcf, strcat(path,'LcOverviewY') , 'epsc');
end



% Vy large
figure;
 
plot(V(:,1), V(:,2:end), 'LineWidth', lw)
title('Value Function');
ylabel('V');
xlabel('y');
xlim([0 0.5])

try
    saveas(gcf, strcat(path,'VyLarge') , 'epsc');
catch %if there is no directory create one
    mkdir(defaultPath, folder)
    saveas(gcf, strcat(path,'VyLarge') , 'epsc');
end

% 
% T = 5;
% %showPeriods=[1 T];
% N = size(kOpt,1);
% showPeriods = [1 3 T];
% reduction=1;
% if N >=100000
%     reduction =100;
% elseif N >=10000
%     reduction = 10;
% elseif N >=5000
%     reduction = 5; 
% end
% reducedIndex = 1:reduction:N;
% kOptReduced = kOpt(reducedIndex,:);
% VReduced = V(reducedIndex,:);
% 
% [pDie, kAbs, kRel, kGrowth, Vabs, Vrel, Vgrowth, VabsVola, VrelVola, Vvola]= ...
%     calcVars(kOptReduced, kOptReduced, param, T);
% 
% for s=1:maxStates
%     figure;
%     title(strcat('State ', num2str(s)));
%     
%     % Probability to Die
%     % ------------------
%     subplot(2,2,1);
%     plot(kOptReduced(:,1), squeeze(pDie(:,s,showPeriods)), 'LineWidth', lw)
%     title('Probability to Die');
%     xlabel('k');
%     
% 
%     % Growth of Capital
%     % -----------------
%     subplot(2,2,2);
%     plot(kOptReduced(:,1), squeeze(kGrowth(:,s,showPeriods)), 'LineWidth', lw)
%     title('Exp. Annualized Growth Rate of Capital');
%     xlabel('k');
%     
%     
%     % Growth Rate of Value
%     % --------------------
%     subplot(2,2,3);
%     plot(kOptReduced(:,1), squeeze(Vgrowth(:,s,showPeriods)), 'LineWidth', lw)
%     title('Exp. Annualized Growth Rate of V');
%     xlabel('k');
%     
% 
%     % Volatility in Value
%     % --------------------
%     subplot(2,2,4);
%     plot(kOptReduced(:,1), squeeze(Vvola(:,s,showPeriods)), 'LineWidth', lw)
%     title('Volatility of Exp. Annualized growth rate of V');
%     xlabel('k');
%     
%     
%     % Save Graph
%     % ----------
%     
%     filename = 'LcGrowthEtcState';
%     filename = strcat(filename, num2str(s));
%     try
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     catch %if there is no directory create one
%         mkdir(defaultPath, folder)
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     end
%     
%     
%     % Everything in absolute Values
%     % ------------------------------
%     
%     figure;
%     title(strcat('State ', num2str(s)));
%     
%     % Probability to Die
%     % ------------------
%     subplot(2,2,1);
%     plot(kOptReduced(:,1), squeeze(pDie(:,s,showPeriods)), 'LineWidth', lw)
%     title('Probability to Die');
%     xlabel('k');
%     
% 
%     % Capital
%     % --------
%     subplot(2,2,2);
%     plot(kOptReduced(:,1), squeeze(kAbs(:,s,1+showPeriods)), 'LineWidth', lw)
%     title('Exp. Capital');
%     xlabel('k');
%     
%     
%     % Value
%     % -----
%     subplot(2,2,3);
%     plot(kOptReduced(:,1), squeeze(Vabs(:,s,1+showPeriods)), 'LineWidth', lw)
%     title('Exp. NPV');
%     xlabel('k');
%     
% 
%     % Vola of Value
%     % --------------
%     subplot(2,2,4);
%     plot(kOptReduced(:,1), squeeze(VabsVola(:,s,1+showPeriods)), 'LineWidth', lw)
%     title('Volatility of NPV');
%     xlabel('k');
%     
%     
%     % Save Graph
%     % ----------
%     
%     filename = 'LcAbsEtcState';
%     filename = strcat(filename, num2str(s));
%     try
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     catch %if there is no directory create one
%         mkdir(defaultPath, folder)
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     end
%     
%     
%     % Everything in relative Values
%     % ------------------------------
%     
%     figure;
%     title(strcat('State ', num2str(s)));
%     
%     % Probability to Die
%     % ------------------
%     subplot(2,2,1);
%     plot(kOptReduced(:,1), squeeze(pDie(:,s,showPeriods)), 'LineWidth', lw)
%     title('Probability to Die');
%     xlabel('k');
%     
%     % Exp. relative Capital
%     % ----------------------
%     subplot(2,2,2);
%     plot(kOptReduced(:,1), squeeze(kRel(:,s,showPeriods)), 'LineWidth', lw)
%     
%     temp = max(max(squeeze(kRel(:,s,showPeriods))))
%     temp = min(temp, 3)
%     ylim([-1, temp])
%     title('Exp. Relative Change of Capital');
%     xlabel('k');
%     
%     
%     % Exp. relative Value
%     % --------------------
%     subplot(2,2,3);
%     plot(kOptReduced(:,1), squeeze(Vrel(:,s,showPeriods)), 'LineWidth', lw)
%     title('Exp. Relative Change of NPV');
%     xlabel('k');
%     
% 
%     % Volatility in relative change of Value
%     % ------------------------------------------
%     subplot(2,2,4);
%     plot(kOptReduced(:,1), squeeze(VrelVola(:,s,showPeriods)), 'LineWidth', lw)
%     title('Volatility of Relative Change in NPV');
%     xlabel('k');
%     
%     
%     
%     % Save Graph
%     % ----------
%     
%     filename = 'LcRelEtcState';
%     filename = strcat(filename, num2str(s));
%     try
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     catch %if there is no directory create one
%         mkdir(defaultPath, folder)
%         saveas(gcf, strcat(path,filename) , 'epsc');
%     end
%     
%     
%     
% end




function [numOfX, numOfY] = positionsInSubPlot(numOfGraph)
    % determines position in a subplot out of the number of graphs
    
    numOfGraph = ceil(numOfGraph);
    if numOfGraph<1
        error('numOfGraph must be at least 1')
    elseif numOfGraph == 1
        numOfX = 1; numOfY = 1;
    elseif numOfGraph == 2
        numOfX = 2; numOfY = 1;
    elseif numOfGraph == 3
        numOfX = 3; numOfY = 1;
    elseif numOfGraph == 4
        numOfX = 2; numOfY = 2;
    elseif numOfGraph == 5 | numOfGraph == 6
        numOfX = 3; numOfY = 2;
    elseif numOfGraph == 8 | numOfGraph == 7
        numOfX = 4; numOfY = 2;
    elseif numOfGraph == 9 
        numOfX = 3; numOfY = 3;
    elseif numOfGraph == 10
        numOfX = 5; numOfY = 2;
    elseif numOfGraph == 11 | numOfGraph == 12
        numOfX = 4; numOfY = 3;
    elseif numOfGraph == 13 | numOfGraph == 14 | numOfGraph == 15
        numOfX = 5; numOfY = 3;
    elseif numOfGraph == 16 
        numOfX = 4; numOfY = 4;
    elseif numOfGraph == 17 | numOfGraph == 18 
        numOfX = 6; numOfY = 3;
    elseif numOfGraph == 19 | numOfGraph == 20 
        numOfX = 5; numOfY = 4;
    elseif numOfGraph == 21 
        numOfX = 7; numOfY = 3;
    elseif numOfGraph == 22 | numOfGraph == 23 | numOfGraph == 24
        numOfX = 6; numOfY = 4;
    elseif numOfGraph == 25
        numOfX = 5; numOfY = 5;
    elseif numOfGraph == 26 | numOfGraph == 27 | numOfGraph == 28
        numOfX = 7; numOfY = 4;
    elseif numOfGraph == 29 | numOfGraph == 30 
        numOfX = 6; numOfY = 5;
    else
        error('To many graphs (more than 30)');
    end
    
function legends(agentNames, location)
    if nargin==1
        location = 0;
    end

    if size(agentNames, 1) == 1
        legend(agentNames(1,:), location);
    elseif size(agentNames, 1) == 2
        legend(agentNames(1,:), agentNames(2,:), location);
    elseif size(agentNames, 1) == 3
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), location);
    elseif size(agentNames, 1) == 4
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), location);
    elseif size(agentNames, 1) == 5
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), location);
     elseif size(agentNames, 1) == 6
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
             agentNames(6,:), location);
     elseif size(agentNames, 1) == 7
        legend(agentNames(1,:), agentNames(2,:),...
            agentNames(3,:), agentNames(4,:), agentNames(5,:), ...
            agentNames(6,:), agentNames(7,:), location);
    else
        error('to many legends');
    end
    