% CobbDouglas Business Cycle (6 examples)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

folder ='CD6PBC'

param.case  = 'CobbDouglas';
param.beta  = 0.95;
param.alpha = 0.8;
param.gamma = 2;
param.delta = 0.1;
param.plot = false;

param.s = [0, 2];

param.p = [0.5, 0.5;
    0.5, 0.5];

param.scale = 1;
param.checked = false;

gridSize = 1/1000 
gridPoints = 0:gridSize:20;
n = numel(gridPoints);
step = max(floor(n/2000),1);
IterMax    = 500
tol = gridSize/10;
p =[0.5 0.75 0.9 0.95 0.975 0.99];

% Calculation: State 1
param.p = [p(1), 1-p(1); 1-p(1) p(1)]
param1 = param;
[Vk1, kOpt1, Vy1, kOptY1]   = Viterate(param1, gridPoints, tol, IterMax);
maxK1  = max(max(kOpt1(:,2:end)));
 
1


% Calculation: State 2
param.p = [p(2), 1-p(2); 1-p(2) p(2)]
param2 = param;
[Vk2, kOpt2, Vy2, kOptY2]   = Viterate(param2, gridPoints, tol, IterMax);
maxK2  = max(max(kOpt2(:,2:end)));

2

% Calculation: State 3
param.p = [p(3), 1-p(3); 1-p(3) p(3)]
param3 = param;
[Vk3, kOpt3, Vy3, kOptY3]   = Viterate(param3, gridPoints, tol, IterMax);
maxK3  = max(max(kOpt3(:,2:end)));

3

% Calculation: State 4
param.p = [p(4), 1-p(4); 1-p(4) p(4)]
param4 = param;
[Vk4, kOpt4, Vy4, kOptY4]   = Viterate(param4, gridPoints, tol, IterMax);
maxK4  = max(max(kOpt4(:,2:end)));

4


% Calculation: State 5
param.p = [p(5), 1-p(5); 1-p(5) p(5)]
param5 = param;
[Vk5, kOpt5, Vy5, kOptY5]   = Viterate(param5, gridPoints, tol, IterMax);
maxK5  = max(max(kOpt5(:,2:end)));


5


% Calculation: State 6
param.p = [p(6), 1-p(6); 1-p(6) p(6)]
param6 = param;
[Vk6, kOpt6, Vy6, kOptY6]   = Viterate(param6, gridPoints, tol, IterMax);
maxK6  = max(max(kOpt6(:,2:end)));


6

save('BCP6.mat');

% Charts
%%%%%%%%%

index = kOpt1(:,1)<= (1.3*max([maxK1; maxK2; maxK3; maxK4; maxK5; maxK6]));
k0 = 1*[1 1 1 1 1 1];
state0 = [1 1 1 1 1 1];
T = 20;

N = sum(index);
reduction = max(1, floor(N/20000));
reducedIndex = 1:reduction:N;

yy = [f(kOpt1(reducedIndex,1), param1.s(1), param1),  f(kOpt1(reducedIndex,1), param1.s(2), param1)];


% Common Plots
%%%%%%%%%%%%%%%

path = 'Graphs\CD6PBC\';
mkdir(cd,path)
lw = 1;
lineTypes = ':|--|-|.-|*|.-|--|:';
set(0, 'DefaultAxesColorOrder',[0 0 1],...
      'DefaultAxesLineStyleOrder',lineTypes);
xLimits = [0 8];

maxK  = 1.5*max(max(kOpt1(:,2:end)));
index = kOpt1(:,1)<=maxK;

% plotY(kOptY1, Vy1, param1, index, 'CD4PBC\L1\')
% plotY(kOptY2, Vy2, param2, index, 'CD4PBC\L2\')
% plotY(kOptY3, Vy3, param3, index, 'CD4PBC\L3\')
% plotY(kOptY4, Vy4, param4, index, 'CD4PBC\L4\')


% Value Function
plotIndex = [2 4 7];
VyS1 = [Vy1(:,1), Vy1(:,2), Vy2(:,2), Vy3(:,2), Vy4(:,2), Vy5(:,2), Vy6(:,2)];
VyS1 = VyS1(index,:);
VyS2 = [Vy1(:,1), Vy1(:,3), Vy2(:,3), Vy3(:,3), Vy4(:,3), Vy5(:,3), Vy6(:,3)];
VyS2 = VyS2(index,:);
yLimits = [-.01 round(max(max(VyS1))+0.5)]

figure; 
subplot(1,2,1);
plot(VyS1(:,1), VyS1(:,2:end), 'LineWidth', lw)
title('(a) Value Function: Boom');
ylabel('V');
xlabel('y');
xlim(xLimits);
ylim(yLimits);

subplot(1,2,2);
plot(VyS2(:,1), VyS2(:,2:end), 'LineWidth', lw)
title('(b) Value Function: Recession');
%ylabel('V');
xlabel('y');
xlim(xLimits);
ylim(yLimits);


% Save Graph
filename = 'Value6PBC';
saveas(gcf, strcat(path,filename) , 'epsc');



figure;
plot(VyS1(:,1), VyS1(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);

% Save Graph
filename = 'VBoom6PBC';
saveToTXT(strcat(path, filename, '.txt'), VyS1 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','VBoom6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);


plot(VyS2(:,1), VyS2(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);

% Save Graph
filename = 'VRecession6PBC';
saveToTXT(strcat(path, filename, '.txt'), VyS2 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','VRecession6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);


% Capital / Dividends
KyS1 = [kOptY1(:,1), kOptY1(:,2), kOptY2(:,2), kOptY3(:,2), kOptY4(:,2), kOptY5(:,2), kOptY6(:,2)];
KyS1 = KyS1(index,:);
KyS2 = [kOptY1(:,1), kOptY1(:,3), kOptY2(:,3), kOptY3(:,3), kOptY4(:,3), kOptY5(:,3), kOptY6(:,3)];
KyS2 = KyS2(index,:);
yLimits = [-.01 xLimits(2)];

nS = size(kOptY1,2)-1;
Dy1  = [kOptY1(:,1), repmat(kOptY1(:,1),1,nS)- kOptY1(:,2:end)];
Dy2  = [kOptY2(:,1), repmat(kOptY2(:,1),1,nS)- kOptY2(:,2:end)];
Dy3  = [kOptY3(:,1), repmat(kOptY3(:,1),1,nS)- kOptY3(:,2:end)];
Dy4  = [kOptY4(:,1), repmat(kOptY4(:,1),1,nS)- kOptY4(:,2:end)];
Dy5  = [kOptY5(:,1), repmat(kOptY5(:,1),1,nS)- kOptY5(:,2:end)];
Dy6  = [kOptY6(:,1), repmat(kOptY4(:,1),1,nS)- kOptY6(:,2:end)];

DyS1 = [Dy1(:,1), Dy1(:,2), Dy2(:,2), Dy3(:,2), Dy4(:,2), Dy5(:,2), Dy6(:,2)];
DyS1 = DyS1(index,:);
DyS2 = [Dy1(:,1), Dy1(:,3), Dy2(:,3), Dy3(:,3), Dy4(:,3), Dy5(:,3), Dy6(:,3)];
DyS2 = DyS2(index,:);



figure;
plot(KyS1(:,1), KyS1(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);
filename = 'KyBoom6PBC';
saveToTXT(strcat(path, filename, '.txt'), KyS1 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','KyBoom6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);


plot(DyS1(:,1), DyS1(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);
filename = 'DyBoom6PBC';
saveToTXT(strcat(path, filename, '.txt'), DyS1 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','DyBoom6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);



plot(KyS2(:,1), KyS2(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);
filename = 'KyRecession6PBC';
saveToTXT(strcat(path, filename, '.txt'), KyS2 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','KyRecession6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);


plot(DyS2(:,1), DyS2(:,plotIndex), 'LineWidth', lw);
xlabel('y');
xlim(xLimits);
ylim(yLimits);
filename = 'DyRecession6PBC';
saveToTXT(strcat(path, filename, '.txt'), KyS2 , 'yV')
filename=strcat(cd, '\Graphs\', folder, '\','DyRecession6PBC.eps');
exportfig(gcf,filename, 'width',6, 'fontmode','fixed', 'fontsize',6);



% Calculations for text
%%%%%%%%%%%%%%%%%%%%%%%%

% Benchmark etc.
longKS1 = max(KyS1);
longKS1 = longKS1(2:end)

longKS2 = max(KyS2);
longKS2 = longKS2(2:end)

param = param1;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench1 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

param = param2;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench2 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

param = param3;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench3 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

param = param4;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench4 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

param = param5;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench5 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

param = param6;
p0 = cumsum(param.p);
kBench = 1./(p0.*param.beta) + param.delta;
kBench6 = (kBench./param.gamma./param.alpha).^(1./(param.alpha-1))

100*longKS1 ./[kBench1(2,1), kBench2(2,1),kBench3(2,1),kBench4(2,1),kBench5(2,1),kBench6(2,1)] -100

[kBench1(1,1) kBench2(1,1) kBench3(1,1) kBench4(1,1) kBench5(1,1) kBench6(1,1) ;
 kBench1(1,2) kBench2(1,2) kBench3(1,2) kBench4(1,2) kBench5(1,2) kBench6(1,2)]

% [0.1:0.1:3; kToSurvive(param, 0.1:0.1:3)']
% [1.7:0.001:1.8; kToSurvive(param, 1.7:0.001:1.8)']
% [1.79:0.00001:1.791; kToSurvive(param, 1.79:0.00001:1.791)']

relS1S2=[VyS1(1001:1000:7001,1), VyS2(1001:1000:7001,2:end)./VyS1(1001:1000:7001,2:end)]
relS1S2 = [ [NaN, p]; relS1S2]


save('BCP6.mat');

% Value Boom Recession

% Plateaus Recession
diagonal = repmat(KyS2(:,1), 1, size(KyS2, 2)-1);
endPoints = KyS2(2:end,2:end)==diagonal(2:end,:)& KyS2(1:(end-1),2:end)~=diagonal(1:(end-1),:);

ind = repmat((1:size(endPoints,1))', 1, size(endPoints, 2));
ind = ind(endPoints==1)
choice = cumsum(sum(endPoints));
choice = choice(sum(endPoints)~=0);
choice = [1 choice(1:(end-1))+1]
lowest(sum(endPoints)==0) = 1;
lowest(sum(endPoints)~=0) = ind(choice)-1

result = sum(endPoints)+1;
result =[result; max(KyS2(:,2:end)); KyS2(lowest, 1)';  KyS2(lowest+size(KyS2,1)*(1:(size(KyS2,2)-1)))]

% Plateaus Boom
diagonal = repmat(KyS1(:,1), 1, size(KyS1, 2)-1);
endPoints = KyS1(2:end,2:end)==diagonal(2:end,:)& KyS1(1:(end-1),2:end)~=diagonal(1:(end-1),:);

ind = repmat((1:size(endPoints,1))', 1, size(endPoints, 2));
ind = ind(endPoints==1)
choice = cumsum(sum(endPoints));
choice = choice(sum(endPoints)~=0);
choice = [1 choice(1:(end-1))+1]
lowest(sum(endPoints)==0) = 1;
lowest(sum(endPoints)~=0) = ind(choice)-1

result = sum(endPoints)+1;
result =[result; KyS2(lowest, 1)'; KyS2(lowest+size(KyS2,1)*(1:(size(KyS2,2)-1)))]



